﻿Imports System
Imports System.IO
Imports System.Text

Public Class frmMain

    Private callbackFunc As clsBXLAPI.StatusCallBackDelegate = Nothing
    Private BXLAPI As New clsBXLAPI

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        InitControls()
        EnableControls(False)
        EnableIFControls(IUsb)
        lblNote.Text = "Note:" + Environment.NewLine
        lblNote.Text += "Display APIs work with " + Environment.NewLine
        lblNote.Text += "SRP-Q300/Q302"
    End Sub
    Private Sub frmMain_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
        BXLAPI = Nothing
    End Sub
    Private Sub rdoIF_Serial_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoIF_Serial.CheckedChanged
        EnableIFControls(ISerial)
    End Sub

    Private Sub rdoIF_Parallel_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoIF_Parallel.CheckedChanged
        EnableIFControls(IParallel)
    End Sub

    Private Sub rdoIF_USB_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoIF_USB.CheckedChanged
        EnableIFControls(IUsb)
    End Sub

    Private Sub rdoIF_Net_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoIF_Lan.CheckedChanged
        EnableIFControls(ILan)
    End Sub

    Private Sub rdoIF_Bluetooth_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoIF_Bluetooth.CheckedChanged
        EnableIFControls(IBluetooth)
    End Sub

    Private Sub rdoIF_WLan_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoIF_WLan.CheckedChanged
        EnableIFControls(IWLan)
    End Sub

    Private Sub InitControls()
        EnableIFControls(IUsb)
        rdoIF_USB.Checked = True
        cmbLPT_Port.SelectedIndex = 0
        cmbCOM_Port.SelectedIndex = 0
        cmbCOM_Baudrate.SelectedItem = "115200"
        cmbCOM_Databits.SelectedItem = "8"
        cmbCOM_Parity.SelectedItem = "NONE"
        cmbCOM_Stopbits.SelectedItem = "1"
        cmbCOM_FlowControl.SelectedItem = "DTR/DSR"
    End Sub

    Private Sub EnableIFControls(ByVal nInterface As Integer)
        cmbLPT_Port.Enabled = (nInterface = IParallel)
        cmbCOM_Port.Enabled = (nInterface = ISerial Or nInterface = IBluetooth)
        cmbCOM_Baudrate.Enabled = (nInterface = ISerial)
        cmbCOM_Databits.Enabled = (nInterface = ISerial)
        cmbCOM_Parity.Enabled = (nInterface = ISerial)
        cmbCOM_Stopbits.Enabled = (nInterface = ISerial)
        cmbCOM_FlowControl.Enabled = (nInterface = ISerial)
        txtNet_IPAddr.Enabled = (nInterface = ILan Or nInterface = IWLan)
        txtNet_PortNum.Enabled = (nInterface = ILan Or nInterface = IWLan)
    End Sub

    Private Sub EnableControls(ByVal bConnected As Boolean)
        btnConnect.Enabled = Not bConnected
        btnDisconnect.Enabled = bConnected
        btnFeedCut.Enabled = bConnected
        btnPrintText.Enabled = bConnected
        btnPrintBitmap.Enabled = bConnected
        btn1DBarcode.Enabled = bConnected
        btn2DBarcode.Enabled = bConnected
        btnDirectIO.Enabled = bConnected
        btnStatus.Enabled = bConnected
        btnPrintSample.Enabled = bConnected
        btnStatus_Set.Enabled = bConnected
        btnStatus_Cancel.Enabled = False
        btnClearScreen.Enabled = bConnected
        btnTextDisplay.Enabled = bConnected
        btnStoreImg.Enabled = bConnected
        btnDisplayImg.Enabled = bConnected
        btnPmDirection.Enabled = bConnected
        btnPmSample.Enabled = bConnected
        btnPresenterStatus.Enabled = bConnected
        btnPrintBitmapLZMA.Enabled = bConnected
        btnPrintFwVersion.Enabled = bConnected
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Dim strPort As String = ""
        Dim nInterface As Integer = ISerial
        Dim nBaudrate As Integer = 115200
        Dim nDatabits As Integer = 8
        Dim nParity As Integer = 0
        Dim nStopbits As Integer = 0
        Dim nFlowControl As Integer = 0

        If (rdoIF_Serial.Checked) Then
            nInterface = ISerial
            strPort = cmbCOM_Port.Text
            nBaudrate = Convert.ToInt32(cmbCOM_Baudrate.Text)
            nDatabits = Convert.ToInt32(cmbCOM_Databits.Text)
            nParity = cmbCOM_Parity.SelectedIndex
            nStopbits = cmbCOM_Stopbits.SelectedIndex
            nFlowControl = cmbCOM_FlowControl.SelectedIndex
        ElseIf (rdoIF_Bluetooth.Checked) Then
            nInterface = IBluetooth
            strPort = cmbCOM_Port.Text
        ElseIf (rdoIF_Parallel.Checked) Then
            nInterface = IParallel
            strPort = cmbLPT_Port.Text
        ElseIf (rdoIF_USB.Checked) Then
            nInterface = IUsb
        ElseIf (rdoIF_Lan.Checked) Then
            nInterface = ILan
            strPort = txtNet_IPAddr.Text
            nBaudrate = Convert.ToInt32(txtNet_PortNum.Text)
        ElseIf (rdoIF_WLan.Checked) Then
            nInterface = IWLan
            strPort = txtNet_IPAddr.Text
            nBaudrate = Convert.ToInt32(txtNet_PortNum.Text)
        End If

        Dim result As Integer
        result = BXLAPI.PrinterOpen(nInterface, strPort, nBaudrate, nDatabits, nParity, nStopbits, nFlowControl)
        If (result = 0) Then
            EnableControls(True)
        Else
            MessageBox.Show("PrinterOpen Failed : Error Code  =" + result.ToString())
        End If
    End Sub

    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        BXLAPI.PrinterClose()
        EnableControls(False)
        statusTextBox.Clear()
    End Sub

    Private Sub btnPrintText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintText.Click
        ' Enters 'Transaction' mode.
        BXLAPI.TransactionStart()

        BXLAPI.InitializePrinter()
        BXLAPI.SetCharacterSet(CHARACTER_SET.BXL_CS_WPC1252)
        BXLAPI.SetInterChrSet(INTERNATIONAL_CHARACTER_SET.BXL_ICS_USA)
        ' Call 'PrintText' with system default code page
        BXLAPI.PrintText("Left, Default" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("Center, Underline" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_UNDERLINE, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("Left, Underline, Bold" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_UNDERLINE Or FT_ATTRIBUTE.BXL_FT_BOLD, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("Left, Underline, Bold, FontB" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_UNDERLINE Or FT_ATTRIBUTE.BXL_FT_BOLD Or FT_ATTRIBUTE.BXL_FT_FONTB, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("Left, Underline, Bold, FontC" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_UNDERLINE Or FT_ATTRIBUTE.BXL_FT_BOLD Or FT_ATTRIBUTE.BXL_FT_FONTC, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("Right, Reverse" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_RIGHT, FT_ATTRIBUTE.BXL_FT_REVERSE, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("Default, 0W 0H" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("Double Width, 1W 0H" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_1WIDTH)
        BXLAPI.PrintText("Double Height, 0W 1H" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_HEIGHT.BXL_TS_1HEIGHT)
        'BXLAPI.PrintText("Color in RED" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_RED_COLOR, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)

        'BXLAPI.PrintTextW("Xin chào" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT, CHARACTER_SET.BXL_CS_TCVN)       ' Vietnamese
        'BXLAPI.PrintTextW("안녕하세요" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT, CHARACTER_SET.BXL_CS_KS5601)   ' Korean
        'BXLAPI.PrintTextW("你好" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT, CHARACTER_SET.BXL_CS_BIG5)           ' Chinese (BIG5)
        'BXLAPI.PrintTextW("你好" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT, CHARACTER_SET.BXL_CS_GB2312)         ' Chinese (gb2312)
        'BXLAPI.PrintTextW("こんにちは" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT, CHARACTER_SET.BXL_CS_SHIFT_JIS) 'Shift_JIS

        BXLAPI.CutPaper()

        ' Only BK3-31 with presenter supported
        BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)


        ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
        If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
            MessageBox.Show("TransactionEnd failed.")
        End If

    End Sub

    Private Sub btn1DBarcode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn1DBarcode.Click
        ' Enters 'Transaction' mode.
        BXLAPI.TransactionStart()


        ' UPC-A
        BXLAPI.PrintText("BARCODE : UPCA" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("012345678912", BCS.BXL_BCS_UPCA, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' UPC-E
        BXLAPI.PrintText("BARCODE : UPCE" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("012345678912", BCS.BXL_BCS_UPCE, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' JAN,EAN8	
        BXLAPI.PrintText("BARCODE : JAN/EAN8" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("01234567", BCS.BXL_BCS_JAN8, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' JAN,EAN13	
        BXLAPI.PrintText("BARCODE : JAN/EAN13" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("012345678912", BCS.BXL_BCS_EAN13, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' Code39
        BXLAPI.PrintText("BARCODE : CODE39" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("0123456789", BCS.BXL_BCS_CODE39, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' ITF
        BXLAPI.PrintText("BARCODE : ITF" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("0123456789", BCS.BXL_BCS_ITF, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' CODABAR
        BXLAPI.PrintText("BARCODE : CODABAR" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("A0123456789", BCS.BXL_BCS_CODABAR, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' CODE3
        BXLAPI.PrintText("BARCODE : CODE93" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("0123456789", BCS.BXL_BCS_CODE93, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.LineFeed(2)
        ' CODE128
        BXLAPI.PrintText("BARCODE : CODE128" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintBarcode("0123456789", BCS.BXL_BCS_CODE128, 50, 2, ALIGN.BXL_ALIGNMENT_LEFT, HRI.BXL_BC_TEXT_BELOW)
        BXLAPI.CutPaper()

        ' Only BK3-31 with presenter supported
        BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)

        ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
        If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
            MessageBox.Show("TransactionEnd failed.")
        End If
    End Sub

    Private Sub btn2DBarcode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn2DBarcode.Click
        ' Enters 'Transaction' mode.
        BXLAPI.TransactionStart()

        BXLAPI.PrintText("PDF417" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintPDF417("1234567890ABCDEFG", PDF417_TYPE.BXL_PDF417_TYPE1, 0, 0, 3, 2, PDF417_ECC.BXL_PDF417_ECC_LEVEL_0, ALIGN.BXL_ALIGNMENT_LEFT)
        BXLAPI.LineFeed(3)
        BXLAPI.PrintText("QRCode" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintQRCode("1234567890ABCDEFG", QRCODE_TYPE.BXL_QRCODE_MODEL1, 4, QRCODE_ECC.BXL_QRCODE_ECC_LEVEL_L, ALIGN.BXL_ALIGNMENT_LEFT)
        BXLAPI.LineFeed(3)
        BXLAPI.PrintText("DataMatrix" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        BXLAPI.PrintDataMatrix("1234567890ABCDEFG", 3, ALIGN.BXL_ALIGNMENT_LEFT)

        'BXLAPI.PrintText("GS1DataBar" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        'BXLAPI.PrintGS1DataBar("1234567890ABCDEFG", GS1DATABAR.BXL_GS1DATABAR_STACKED, 3, ALIGN.BXL_ALIGNMENT_LEFT)
        'BXLAPI.LineFeed(3)
        'BXLAPI.PrintText("CompositeSymbology" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_LEFT, 0, 0)
        'BXLAPI.PrintCompositeSymbology("1234567890", COMPOSITE_1D.BXL_COMPOSITE_LINE_EAN8, "ABCDEFGHIJ", COMPOSITE_2D.BXL_COMPOSITE_2D_AUTO, 2, ALIGN.BXL_ALIGNMENT_LEFT)

        BXLAPI.CutPaper()

        ' Only BK3-31 with presenter supported
        BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)

        ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
        If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
            MessageBox.Show("TransactionEnd failed.")
        End If

    End Sub

    Private Sub btnPrintBitmap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintBitmap.Click
        Dim openFileDialog1 As New OpenFileDialog()
        openFileDialog1.Filter = "bmp files (*.bmp)|*.bmp"
        openFileDialog1.RestoreDirectory = True
        If openFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            ' Enters 'Transaction' mode.
            BXLAPI.TransactionStart()

            BXLAPI.PrintBitmap(openFileDialog1.FileName, IMAGE_WIDTH.BXL_WIDTH_NONE, ALIGN.BXL_ALIGNMENT_CENTER, 50, True)
            BXLAPI.CutPaper()

            ' Only BK3-31 with presenter supported
            BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)

            ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
            If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
                MessageBox.Show("TransactionEnd failed.")
            End If
        End If

    End Sub

    Private Sub btnFeedCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFeedCut.Click
        BXLAPI.CutPaper()
        ' Only BK3-31 with presenter supported
        BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)
    End Sub

    Private Sub btnPrintSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintSample.Click
        ' Enters 'Transaction' mode.
        BXLAPI.TransactionStart()

        BXLAPI.InitializePrinter()
        BXLAPI.SetCharacterSet(CHARACTER_SET.BXL_CS_WPC1252)
        BXLAPI.SetInterChrSet(INTERNATIONAL_CHARACTER_SET.BXL_ICS_USA)

        BXLAPI.PrintText("Receipt", ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD Or FT_ATTRIBUTE.BXL_FT_UNDERLINE, FT_WIDTH.BXL_TS_1WIDTH Or FT_HEIGHT.BXL_TS_1HEIGHT)
        BXLAPI.PrintText(" " + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD Or FT_ATTRIBUTE.BXL_FT_UNDERLINE, FT_WIDTH.BXL_TS_1WIDTH Or FT_HEIGHT.BXL_TS_1HEIGHT)

        BXLAPI.PrintText("------------------------------" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText(" Apple      3             $3.0" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText(" Cola       1             $1.2" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText(" Milk       2             $1.8" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText(" Juice      1             $2.0" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("------------------------------" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText(" Total                    $8.0" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText(" Cash                     $8.0" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("                          $0.0" + Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)

        BXLAPI.PrintText("Test", ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("BBB", ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_FONTB Or FT_ATTRIBUTE.BXL_FT_BOLD, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("CCC", ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_FONTB Or FT_ATTRIBUTE.BXL_FT_REVERSE, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText("DDD", ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD Or FT_ATTRIBUTE.BXL_FT_UNDERLINE, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintText(Environment.NewLine, ALIGN.BXL_ALIGNMENT_CENTER, FT_ATTRIBUTE.BXL_FT_BOLD Or FT_ATTRIBUTE.BXL_FT_UNDERLINE, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.PrintBarcode("12345678", BCS.BXL_BCS_ITF, 100, 2, ALIGN.BXL_ALIGNMENT_CENTER, HRI.BXL_BC_TEXT_BELOW)

        BXLAPI.OpenDrawer(DRAWER.BXL_CASHDRAWER_PIN2)
        'BXLAPI.OpenDrawer(DRAWER.BXL_CASHDRAWER_PIN5)
        BXLAPI.CutPaper()

        ' Only BK3-31 with presenter supported
        BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)

        ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
        If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
            MessageBox.Show("TransactionEnd failed.")
        End If
    End Sub

    Private Sub btnStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStatus.Click
        Dim strStatus As String
        Dim lState As Integer

        lState = BXLAPI.GetPrinterCurrentStatus()

        strStatus = "Printer Status = "
        If (lState = PRN_STATUS.BXL_STS_NORMAL) Then
            strStatus += " NORMAL "
        End If
        If (lState And PRN_STATUS.BXL_STS_PAPER_NEAR_END) Then
            strStatus += " PAPER NEAR END "
        End If
        If (lState And PRN_STATUS.BXL_STS_PAPEREMPTY) Then
            strStatus += " PAPER EMPTY "
        End If
        If (lState And PRN_STATUS.BXL_STS_CASHDRAWER_HIGH) Then
            strStatus += " CASHDRAWER HIGH "
        End If
        If (lState And PRN_STATUS.BXL_STS_CASHDRAWER_LOW) Then
            strStatus += " CASHDRAWER LOW "
        End If
        If (lState And PRN_STATUS.BXL_STS_COVEROPEN) Then
            strStatus += " COVER OPEN "
        End If
        If (lState And PRN_STATUS.BXL_STS_BATTERY_LOW) Then
            strStatus += " BATTERY LOW "
        End If
        If (lState And PRN_STATUS.BXL_STS_PAPER_TO_BE_TAKEN) Then
            strStatus += " PAPER PRESENCE "
        End If

        MessageBox.Show(strStatus)

    End Sub

    Private Sub btnDirectIO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDirectIO.Click
        Dim readByte(32) As Byte
        Dim readByteLength As UInt32
        readByteLength = readByte.Length
        Dim lResult As UInt32

        lResult = BXLAPI.DirectIO(New Byte() {&H10, &H4, &H2}, 3, readByte, readByteLength)
        If (lResult <> 0) Then
            MessageBox.Show("Error Code = " + lResult.ToString())
        Else
            MessageBox.Show("Read Data = 0x" + readByte(0).ToString("X"))
        End If

    End Sub

    Public Function StatusCallBackSMethod(ByVal nStatus As Integer) As Integer
        interpretPrinterStatusData(nStatus)
        Return 0
    End Function

    Private Sub interpretPrinterStatusData(ByVal status As Integer)
        statusTextBox.AppendText(DateTime.Now + " : " + Environment.NewLine)
        If (status = PRN_STATUS.BXL_STS_NORMAL) Then
            statusTextBox.AppendText(" - NORMAL" + Environment.NewLine)
        End If
        If (status And PRN_STATUS.BXL_STS_PAPER_NEAR_END) Then
            statusTextBox.AppendText(" - PAPER-NEAR-END" + Environment.NewLine)
        End If
        If (status And PRN_STATUS.BXL_STS_PAPEREMPTY) Then
            statusTextBox.AppendText(" - PAPER-EMPTY" + Environment.NewLine)
        End If
        If (status And PRN_STATUS.BXL_STS_CASHDRAWER_HIGH) Then
            statusTextBox.AppendText(" - CASHDRAWER-HIGH" + Environment.NewLine)
        End If
        If (status And PRN_STATUS.BXL_STS_CASHDRAWER_LOW) Then
            statusTextBox.AppendText(" - CASHDRAWER-LOW" + Environment.NewLine)
        End If
        If (status And PRN_STATUS.BXL_STS_COVEROPEN) Then
            statusTextBox.AppendText(" - COVER-OPEN" + Environment.NewLine)
        End If
        If (status And PRN_STATUS.BXL_STS_BATTERY_LOW) Then
            statusTextBox.AppendText(" - BATTERY-LOW" + Environment.NewLine)
        End If
        If (status And PRN_STATUS.BXL_STS_PAPER_TO_BE_TAKEN) Then
            statusTextBox.AppendText(" - PAPER-PRESENCE" + Environment.NewLine)
        End If
    End Sub

    Private Sub btnStatus_Set_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStatus_Set.Click
        callbackFunc = AddressOf StatusCallBackSMethod
        BXLAPI.BidiSetCallBack(callbackFunc)
        btnStatus_Set.Enabled = False
        btnStatus_Cancel.Enabled = True
    End Sub

    Private Sub btnStatus_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStatus_Cancel.Click
        BXLAPI.BidiCancelCallBack()
        btnStatus_Set.Enabled = True
        btnStatus_Cancel.Enabled = False
    End Sub

    Private Sub btnClearScreen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearScreen.Click
        BXLAPI.ClearScreen()        ' Clear screen (all lines)            
        'BXLAPI.ClearLine(1)        ' Clear 1st line
        'BXLAPI.ClearLine(2)        ' Clear 2nd line
    End Sub

    Private Sub btnStoreImg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStoreImg.Click
        Dim openFileDialog1 As New OpenFileDialog()
        openFileDialog1.Filter = "bmp files (*.bmp)|*.bmp|All files (*.*)|*.*"
        openFileDialog1.RestoreDirectory = True
        If openFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            BXLAPI.StoreImageFile(openFileDialog1.FileName, 1)
            ' BCD-3000
            ' 0 <= x Posistion <= 160 
            ' 0 <= y Posistion <= 32
            BXLAPI.DisplayImage(1, 0, 0)
        End If
    End Sub

    Private Sub btnTextDisplay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextDisplay.Click
        BXLAPI.SetInternationalCharacterset(INTERNATIONAL_CHARACTER_SET.BXL_ICS_USA)
        BXLAPI.DisplayString("TEST ")
        'BXLAPI.DisplayStringW("TEST ", BCD_CHARACTER_SET.BXL_TEXT_ENCODE_PC437)
        'BXLAPI.DisplayStringAtLine(1, "TEST ")
        'BXLAPI.DisplayStringAtLine(2, "TEST ")
        'BXLAPI.DisplayStringAtLineW(1, "TEST ", BCD_CHARACTER_SET.BXL_TEXT_ENCODE_PC437)
        'BXLAPI.DisplayStringAtLineW(2, "TEST ", BCD_CHARACTER_SET.BXL_TEXT_ENCODE_PC437)
    End Sub

    Private Sub btnDisplayImg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisplayImg.Click
        BXLAPI.DisplayImage(1, 0, 0)
    End Sub

    Private Sub btnPmDirection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPmDirection.Click
        ' Enters 'Transaction' mode.
        BXLAPI.TransactionStart()

        BXLAPI.InitializePrinter()
        BXLAPI.SetPagemode(PM_MODE.BXL_PRINTER_PAGEMODE_IN)
        BXLAPI.SetPagemodePrintArea(0, 0, 512, 600)
        BXLAPI.SetPagemodeDirection(PM_DIRECTION.BXL_PRINTER_PD_0)
        BXLAPI.PrintText("Left to right", ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.SetPagemodeDirection(PM_DIRECTION.BXL_PRINTER_PD_LEFT90)
        BXLAPI.PrintText("Bottom to Top", ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.SetPagemodeDirection(PM_DIRECTION.BXL_PRINTER_PD_180)
        BXLAPI.PrintText("Right to Left", ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.SetPagemodeDirection(PM_DIRECTION.BXL_PRINTER_PD_RIGHT90)
        BXLAPI.PrintText("Top to Bottom", ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        BXLAPI.SetPagemode(PM_MODE.BXL_PRINTER_PAGEMODE_OUT)
        BXLAPI.CutPaper()

        ' Only BK3-31 with presenter supported
        BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)

        ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
        If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
            MessageBox.Show("TransactionEnd failed.")
        End If
    End Sub

    Private Sub btnPmSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPmSample.Click
        ' Enters 'Transaction' mode.
        BXLAPI.TransactionStart()

        Dim xPosition As Integer = 50
        Dim yPosition As Integer = 50

        BXLAPI.InitializePrinter()
        BXLAPI.SetPagemode(PM_MODE.BXL_PRINTER_PAGEMODE_IN)
        BXLAPI.SetPagemodePrintArea(0, 0, 512, 600)
        BXLAPI.SetPagemodeDirection(PM_DIRECTION.BXL_PRINTER_PD_RIGHT90)
        BXLAPI.SetPagemodePosition(xPosition, yPosition)
        BXLAPI.PrintText("Sample Text", ALIGN.BXL_ALIGNMENT_LEFT, FT_ATTRIBUTE.BXL_FT_DEFAULT, FT_WIDTH.BXL_TS_0WIDTH Or FT_HEIGHT.BXL_TS_0HEIGHT)
        yPosition += 70
        BXLAPI.SetPagemodePosition(xPosition, yPosition)
        BXLAPI.PrintBarcode("12345678", BCS.BXL_BCS_CODE128, 100, 2, ALIGN.BXL_ALIGNMENT_CENTER, HRI.BXL_BC_TEXT_NONE)
        BXLAPI.SetPagemode(PM_MODE.BXL_PRINTER_PAGEMODE_OUT)
        BXLAPI.CutPaper()

        ' Only BK3-31 with presenter supported
        BXLAPI.PaperEject(EJ_OPTION.BXL_EJT_HOLD)

        ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
        If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
            MessageBox.Show("TransactionEnd failed.")
        End If
    End Sub
    Private Sub btnPresenterStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPresenterStatus.Click
        Dim strStatus As String
        Dim lState As Integer

        lState = BXLAPI.GetPresenterStatus()

        strStatus = "Printer Status = "
        If (lState = PRT_STATUS.BXL_PRT_STS_NORMAL) Then
            strStatus += " NORMAL "
        End If
        If (lState And PRT_STATUS.BXL_PRT_STS_PAPER_NEAR_END) Then
            strStatus += " PAPER NEAR END "
        End If
        If (lState And PRT_STATUS.BXL_PRT_STS_PAPEREMPTY) Then
            strStatus += " PAPER EMPTY "
        End If
        If (lState And PRT_STATUS.BXL_PRT_STS_PAPER_IN) Then
            strStatus += " PAPER IN PRESENTER "
        End If
        If (lState And PRT_STATUS.BXL_PRT_STS_PAPER_JAM) Then
            strStatus += " PAPER JAM "
        End If
        If (lState = BXL_RESULT.BXL_NOT_SUPPORT) Then
            strStatus = " Only BK3-31 with presenter supported "
        End If


        MessageBox.Show(strStatus)

    End Sub

    Private Sub btnPrintBitmapLZMA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintBitmapLZMA.Click
        Dim openFileDialog1 As New OpenFileDialog()
        openFileDialog1.Filter = "bmp files (*.bmp)|*.bmp"
        openFileDialog1.RestoreDirectory = True
        If openFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            ' Enters 'Transaction' mode.
            BXLAPI.TransactionStart()

            BXLAPI.PrintBitmapLZMA(openFileDialog1.FileName, IMAGE_WIDTH.BXL_WIDTH_NONE, ALIGN.BXL_ALIGNMENT_CENTER, 50, True)
            BXLAPI.CutPaper()

            ' Leaves 'Transaction' mode, and then sends print data in the buffer to start printing.
            If (BXLAPI.TransactionEnd(True, 3000) < 0) Then
                MessageBox.Show("TransactionEnd failed.")
            End If
        End If
    End Sub

    Private Sub btnPrintFwVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintFwVersion.Click
        Dim buffer(30) As Byte
        Dim bufferSizeInBytes As UInt32
        Dim fwString As String
        bufferSizeInBytes = buffer.Length
        Dim lResult As UInt32
        lResult = BXLAPI.GetPrinterFirmwareVersion(buffer, bufferSizeInBytes)
        If (lResult <> 0) Then
            MessageBox.Show("Error Code = " + lResult.ToString())
        Else
            fwString = System.Text.Encoding.UTF8.GetString(buffer)
            MessageBox.Show("FW Version : " + fwString)
        End If
    End Sub
End Class
